//  **** BEGIN LICENSE BLOCK ****
//  Copyright(c) 2005 Adam Judson
//
//  PhotoMap
//  - display user contributed photos on maps.
//
//  This program is free software; you can redistribute it and/or modify it under
//  the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
//  Place, Suite 330, Boston, MA 02111-1307 USA
//
//  **** END LICENSE BLOCK ****



//
//  PhotoMapOptions is the controller for PhotoMapOptions.xul
//  The PhotoMapPreferences class is used to access the values we 
//  get and set.
//
//

// this may be a dead file...

function PhotoMapOptions() {
}


PhotoMapOptions.init = function() {
   PhotoMapOptions.instance = new PhotoMapOptions();
   // this can't happen in the constructor
   // because the selection callback needs the instance value
   PhotoMapOptions.instance.init();
}


PhotoMapOptions.prototype = {
   __proto__ : new PhotoMapLanguage("photomap.options."),

   init : function() {
      this.preferences = new PhotoMapPreferences();
      this.selectedMapType = this.preferences.getMapType();
      this.getScreenObjects();
      this.prefillScreen();
   },

   getScreenObjects : function() {
      this.mapChoiceList   = document.getElementById("photomap.options.map.list");
      this.photoSeason     = document.getElementById("photomap.options.photo.season");
      this.photoPOV        = document.getElementById("photomap.options.photo.pov");
   },

   prefillScreen : function() {
      var key;
      var maps = this.preferences.getMapsList();
      var selectedIndex = 0;
      for (key in maps) {
         this.addMapEntry(this.mapChoiceList, maps[key], maps[key]);
         if (maps[key] == this.selectedMapType) {
            selectedIndex = key;
         }
      }
      if (this.mapChoiceList.getRowCount() > selectedIndex) {
         // this is having the side effect of disabling this item.  wtf?
         this.mapChoiceList.selectItem(this.mapChoiceList.getItemAtIndex(selectedIndex));
      }
   },

   addMapEntry : function(parent, key, label) {
      var item = parent.appendItem(label);
      item.setAttribute("photomap.key", key);
   },

   mapSelectionChange: function() {
      var item = this.mapChoiceList.selectedItem;
      if (item != null) {
         var key = item.getAttribute("photomap.key");
         if (key != this.selectedMapType) {
            this.preferences.setMapType(key);
         }
      }
   },

   enable : function(control, enable) {
      if (enable) {
         control.removeAttribute("disabled");
      } else {
         control.setAttribute("disabled", "true");
      }
   }
}
